﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Anito.Data;
using Anito.Data.Configuration;

namespace Freetime.Configuration
{
    public static class ConfigurationManager
    {
        public static ISession GetDefaultSession()
        {
            IProvider provider = ProviderFactory.GetProvider();
            return new Freetime.Base.Data.DataSession(provider);   
        }

        private static FreetimeConfiguration m_freetimeConfig = null;
        public static FreetimeConfiguration FreetimeConfig
        {
            get
            {
                if (m_freetimeConfig == null)
                {
                    var config = System.Configuration.ConfigurationManager.GetSection("Freetime.Configuration");
                    if (config == null)
                        throw new Exception("Freetime.Configuration not implemented");                    
                    m_freetimeConfig = config as FreetimeConfiguration;
                }
                return m_freetimeConfig;
            }
        }

        public static void SetFreetimeConfig(FreetimeConfiguration config)
        {
            m_freetimeConfig = config;
        }
    }
}
